#!/usr/bin/perl
###################################################################
###      File: /home/users2/schmid/src/TBProgs/TMod/compare-traces.perl
###    Author: Helmut Schmid                                    ###
###   Purpose:                                                  ###
###   Created: Mon Jan 30 16:54:31 2006                         ###
###  Modified: Fri Feb 10 10:23:15 2006 (schmid)                ###
### Copyright: Institut fuer maschinelle Sprachverarbeitung     ###
###               Universitaet Stuttgart                        ###
###################################################################

# use Getopt::Std;
# getopts('h');

$filename1 = shift;
$filename2 = shift or die "Error: two arguments required!\n";

open(FILE,$filename1) or die "Error: unable to open \"$filename1\"!\n";
while (<FILE>) {
  chomp;
  @F = split();
  if ($#F == 0) {
    $n = $F[0];
  }
  elsif ($#F == 2) {
    $ec1{"$n\t$F[0] $F[1] $F[2]"} = "0";
  }
  elsif ($#F == 4) {
    if ($F[1] eq '*U*' ||
	($F[1] eq '0' && $F[2] eq 'SBAR'))
      {
	$F[2] = '';
      }
    $ec1{"$n\t$F[0] $F[1] $F[2]"} = "$F[3] $F[4]";
  }
}
close FILE;

open(FILE,$filename2) or die "Error: unable to open \"$filename2\"!\n";
while (<FILE>) {
  chomp;
  @F = split();
  if ($#F == 0) {
    $n = $F[0];
  }
  elsif ($#F == 2) {
    $ec2{"$n\t$F[0] $F[1] $F[2]"} = "0";
  }
  elsif ($#F == 4) {
    $ec2{"$n\t$F[0] $F[1] $F[2]"} = "$F[3] $F[4]";
  }
}
close FILE;

foreach $l (keys %ec1) {
  if (exists $ec2{$l}) {
    print "$l\t$ec1{$l}\t$ec2{$l}\n";
  }
  else {
    print "$l\t$ec1{$l}\t-\n";
  }
}

foreach $l (keys %ec2) {
  unless (exists $ec1{$l}) {
    print "$l\t-\t$ec2{$l}\n";
  }
}

