#!/usr/bin/perl

while (<>) {
  chomp;
  s/(\*U\*) [A-Z]+/$1/;
  s/SBARXS/SBAR-S/;

  @F=split(/\t/);
  @G=split(/ /,$F[1]);
  @H=split(/ /,$F[2]);
  @K=split(/ /,$F[3]);

  # recognition of empty elements
  if ($F[2] eq '-') {
    $fp++;
    #printf "%3d  %-15s %-10s ++\n", $F[0], $F[1], $F[3];
    $fp{"$G[2] $G[1]"}++;
    $t{"$G[2] $G[1]"} = 1;
  }
  elsif ($F[3] eq '-') {
    $fn++;
    #printf "%3d  %-15s %-10s --\n", $F[0], $F[1], $F[2];
    $fn{"$G[2] $G[1]"}++;
    $t{"$G[2] $G[1]"} = 1;
  }
  else {
    $tp++;
    #printf "%3d  %-15s %-10s\n", $F[0], $F[1], $F[2];
    $tp{"$G[2] $G[1]"}++;
    $t{"$G[2] $G[1]"} = 1;
  }

  # checking co-indexation
  if ($F[2] =~ / /) { # is a trace in the gold standard?
    if ($F[2] eq $F[3]) {
      $citp++;
      #printf "%3d  %-15s %-10s\n", $F[0], $F[1], $F[2];
      $citp{"$H[1] $G[2] $G[1]"}++;
      $ci{"$H[1] $G[2] $G[1]"} = 1;
    }
    else {
      $cifn++;
      #printf "%3d  %-15s %-10s --\n", $F[0], $F[1], $F[3];
      $cifn{"$H[1] $G[2] $G[1]"}++;
      $ci{"$H[1] $G[2] $G[1]"} = 1;
    }
  }
  if ($F[3] =~ / / && $F[2] ne $F[3]) { # is a trace in the parser output?
    $cifp++;
    #printf "%3d  %-15s %-10s ++\n", $F[0], $F[1], $F[2];
    $cifp{"$K[1] $G[2] $G[1]"}++;
    $ci{"$K[1] $G[2] $G[1]"} = 1;
  }
}

print "\nEE Recognition\n";

printf "\t\tprec.\trecall\tf-score\ttp\tfp\tfn\n";

foreach $k (sort {$tp{$b}+$fn{$b} <=> $tp{$a}+$fn{$a}} keys %t) {
  $prec = $recall = $fscore = 0.0;
  if ($tp{$k} > 0) {
    $prec = $tp{$k}/($tp{$k}+$fp{$k});
    $recall = $tp{$k}/($tp{$k}+$fn{$k});
    $fscore = 2*$prec*$recall/($prec+$recall);
  }
  printf "%-15s\t%.1f\t%.1f\t%.1f\t%d\t%d\t%d\t%d\n", $k,
    100*$prec, 100*$recall, 100*$fscore, $tp{$k}, $fp{$k}, $fn{$k}, 
      $tp{$k}+$fn{$k};
}

$prec = $tp/($tp+$fp);
$recall = $tp/($tp+$fn);
$fscore = 2*$prec*$recall/($prec+$recall);

printf "overall\t\t%.2f\t%.2f\t%.2f\t%d\t%d\t%d\t%d\n", 
  100*$prec, 100*$recall, 100*$fscore, $tp, $fp, $fn, $tp+$fn;

print "\nAntecedent Recovery\n";

printf "\t\tprec.\trecall\tf-score\ttp\tfp\tfn\n";

foreach $k (sort {$citp{$b}+$cifn{$b} <=> $citp{$a}+$cifn{$a}} keys %ci) {
  $prec = $recall = $fscore = 0.0;
  if ($citp{$k} > 0) {
    $prec = $citp{$k}/($citp{$k}+$cifp{$k});
    $recall = $citp{$k}/($citp{$k}+$cifn{$k});
    $fscore = 2*$prec*$recall/($prec+$recall);
  }
  printf "%-15s\t%.1f\t%.1f\t%.1f\t%d\t%d\t%d\t%d\n", $k,
    100*$prec, 100*$recall, 100*$fscore, $citp{$k}, $cifp{$k}, $cifn{$k},
      $citp{$k}+$cifn{$k};
}

$prec = $citp/($citp+$cifp);
$recall = $citp/($citp+$cifn);
$fscore = 2*$prec*$recall/($prec+$recall);

printf "overall\t\t%.2f\t%.2f\t%.2f\t%d\t%d\t%d\t%d\n", 
  100*$prec, 100*$recall, 100*$fscore, $citp, $cifp, $cifn, $citp+$cifn;

